From 54d72657e44c4abeb70189dc6b74d81ba4b0194c Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Mon, 26 Jul 2021 17:52:43 +0000
Subject: [PATCH] [arm64] port cpy2Dto1D_{shl,shr} and cpy1Dto2D_{shl,shr}

    cpy2Dto1D_shl[4x4]	15.69x 	 6.73     	 105.60
    cpy2Dto1D_shr[4x4]	12.97x 	 6.65     	 86.28
    cpy2Dto1D_shl[8x8]	43.32x 	 8.85     	 383.16
    cpy2Dto1D_shr[8x8]	34.56x 	 9.75     	 336.91
  cpy2Dto1D_shl[16x16]	52.93x 	 21.95    	 1161.97
  cpy2Dto1D_shr[16x16]	52.10x 	 27.88    	 1452.72
  cpy2Dto1D_shl[32x32]	68.29x 	 89.12    	 6085.54
  cpy2Dto1D_shr[32x32]	38.55x 	 105.73   	 4076.24

    cpy1Dto2D_shl[4x4]	19.04x 	 5.63     	 107.16
cpy1Dto2D_shl_aligned[4x4]	19.22x 	 5.60     	 107.68
    cpy1Dto2D_shr[4x4]	15.32x 	 6.52     	 99.89
    cpy1Dto2D_shl[8x8]	47.59x 	 8.27     	 393.34
cpy1Dto2D_shl_aligned[8x8]	47.22x 	 8.28     	 390.90
    cpy1Dto2D_shr[8x8]	36.68x 	 9.74     	 357.15
  cpy1Dto2D_shl[16x16]	71.02x 	 21.51    	 1527.64
cpy1Dto2D_shl_aligned[16x16]	69.37x 	 21.71    	 1506.23
  cpy1Dto2D_shr[16x16]	39.06x 	 28.23    	 1102.52
  cpy1Dto2D_shl[32x32]	68.19x 	 89.34    	 6092.00
cpy1Dto2D_shl_aligned[32x32]	70.01x 	 89.26    	 6248.95
  cpy1Dto2D_shr[32x32]	56.47x 	 105.90   	 5979.45
---
 source/common/aarch64/asm-primitives.cpp |  28 +++
 source/common/aarch64/blockcopy8.h       |  15 ++
 source/common/aarch64/mc-a.S             | 276 +++++++++++++++++++++++
 3 files changed, 319 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index f3434c6..ce041f6 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -312,6 +312,34 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.chroma[X265_CSP_I422].cu[BLOCK_422_16x32].copy_sp = PFX(blockcopy_sp_16x32_neon);
         p.chroma[X265_CSP_I422].cu[BLOCK_422_32x64].copy_sp = PFX(blockcopy_sp_32x64_neon);
 
+        // cpy2Dto1D_shl
+        p.cu[BLOCK_4x4].cpy2Dto1D_shl   = PFX(cpy2Dto1D_shl_4x4_neon);
+        p.cu[BLOCK_8x8].cpy2Dto1D_shl   = PFX(cpy2Dto1D_shl_8x8_neon);
+        p.cu[BLOCK_16x16].cpy2Dto1D_shl = PFX(cpy2Dto1D_shl_16x16_neon);
+        p.cu[BLOCK_32x32].cpy2Dto1D_shl = PFX(cpy2Dto1D_shl_32x32_neon);
+
+        // cpy2Dto1D_shr
+        p.cu[BLOCK_4x4].cpy2Dto1D_shr   = PFX(cpy2Dto1D_shr_4x4_neon);
+        p.cu[BLOCK_8x8].cpy2Dto1D_shr   = PFX(cpy2Dto1D_shr_8x8_neon);
+        p.cu[BLOCK_16x16].cpy2Dto1D_shr = PFX(cpy2Dto1D_shr_16x16_neon);
+        p.cu[BLOCK_32x32].cpy2Dto1D_shr = PFX(cpy2Dto1D_shr_32x32_neon);
+
+        // cpy1Dto2D_shl
+        p.cu[BLOCK_4x4].cpy1Dto2D_shl[ALIGNED]      = PFX(cpy1Dto2D_shl_4x4_neon);
+        p.cu[BLOCK_8x8].cpy1Dto2D_shl[ALIGNED]      = PFX(cpy1Dto2D_shl_8x8_neon);
+        p.cu[BLOCK_16x16].cpy1Dto2D_shl[ALIGNED]    = PFX(cpy1Dto2D_shl_16x16_neon);
+        p.cu[BLOCK_32x32].cpy1Dto2D_shl[ALIGNED]    = PFX(cpy1Dto2D_shl_32x32_neon);
+        p.cu[BLOCK_4x4].cpy1Dto2D_shl[NONALIGNED]   = PFX(cpy1Dto2D_shl_4x4_neon);
+        p.cu[BLOCK_8x8].cpy1Dto2D_shl[NONALIGNED]   = PFX(cpy1Dto2D_shl_8x8_neon);
+        p.cu[BLOCK_16x16].cpy1Dto2D_shl[NONALIGNED] = PFX(cpy1Dto2D_shl_16x16_neon);
+        p.cu[BLOCK_32x32].cpy1Dto2D_shl[NONALIGNED] = PFX(cpy1Dto2D_shl_32x32_neon);
+
+        // cpy1Dto2D_shr
+        p.cu[BLOCK_4x4].cpy1Dto2D_shr   = PFX(cpy1Dto2D_shr_4x4_neon);
+        p.cu[BLOCK_8x8].cpy1Dto2D_shr   = PFX(cpy1Dto2D_shr_8x8_neon);
+        p.cu[BLOCK_16x16].cpy1Dto2D_shr = PFX(cpy1Dto2D_shr_16x16_neon);
+        p.cu[BLOCK_32x32].cpy1Dto2D_shr = PFX(cpy1Dto2D_shr_32x32_neon);
+
         // blockcopy
         p.pu[LUMA_16x16].copy_pp = PFX(blockcopy_pp_16x16_neon);
         p.pu[LUMA_8x4].copy_pp   = PFX(blockcopy_pp_8x4_neon);
diff --git a/source/common/aarch64/blockcopy8.h b/source/common/aarch64/blockcopy8.h
index c348e87..c1a45d2 100644
--- a/source/common/aarch64/blockcopy8.h
+++ b/source/common/aarch64/blockcopy8.h
@@ -68,11 +68,26 @@ void x265_blockcopy_pp_16x24_neon(pixel* dst, intptr_t dstStride, const pixel* s
 void x265_blockcopy_pp_24x64_neon(pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
 void x265_blockcopy_pp_32x48_neon(pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
 
+void x265_cpy2Dto1D_shl_4x4_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
+void x265_cpy2Dto1D_shl_8x8_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
+void x265_cpy2Dto1D_shl_16x16_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
+void x265_cpy2Dto1D_shl_32x32_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
+
 void x265_cpy2Dto1D_shr_4x4_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
 void x265_cpy2Dto1D_shr_8x8_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
 void x265_cpy2Dto1D_shr_16x16_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
 void x265_cpy2Dto1D_shr_32x32_neon(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift);
 
+void x265_cpy1Dto2D_shl_4x4_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+void x265_cpy1Dto2D_shl_8x8_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+void x265_cpy1Dto2D_shl_16x16_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+void x265_cpy1Dto2D_shl_32x32_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+
+void x265_cpy1Dto2D_shr_4x4_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+void x265_cpy1Dto2D_shr_8x8_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+void x265_cpy1Dto2D_shr_16x16_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+void x265_cpy1Dto2D_shr_32x32_neon(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift);
+
 void x265_blockcopy_sp_4x4_neon(pixel* a, intptr_t stridea, const int16_t* b, intptr_t strideb);
 void x265_blockcopy_sp_8x8_neon(pixel* a, intptr_t stridea, const int16_t* b, intptr_t strideb);
 void x265_blockcopy_sp_16x16_neon(pixel* a, intptr_t stridea, const int16_t* b, intptr_t strideb);
diff --git a/source/common/aarch64/mc-a.S b/source/common/aarch64/mc-a.S
index ba8fbfe..d4c665b 100644
--- a/source/common/aarch64/mc-a.S
+++ b/source/common/aarch64/mc-a.S
@@ -439,3 +439,279 @@ pixel_avg_pp_64xN_neon 16 4
 pixel_avg_pp_64xN_neon 32 8
 pixel_avg_pp_64xN_neon 48 12
 pixel_avg_pp_64xN_neon 64 16
+
+// void cpy2Dto1D_shl(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift)
+.macro cpy2Dto1D_shl_start
+    add             x2, x2, x2
+    dup             v0.8h, w3
+.endm
+
+function x265_cpy2Dto1D_shl_4x4_neon
+    cpy2Dto1D_shl_start
+    ld1             {v2.d}[0], [x1], x2
+    ld1             {v2.d}[1], [x1], x2
+    ld1             {v3.d}[0], [x1], x2
+    ld1             {v3.d}[1], [x1], x2
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0]
+    ret
+endfunc
+
+function x265_cpy2Dto1D_shl_8x8_neon
+    cpy2Dto1D_shl_start
+.rept 4
+    ld1             {v2.16b}, [x1], x2
+    ld1             {v3.16b}, [x1], x2
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0], #32
+.endr
+    ret
+endfunc
+
+function x265_cpy2Dto1D_shl_16x16_neon
+    cpy2Dto1D_shl_start
+    mov             w12, #4
+.loop_cpy2Dto1D_shl_16:
+    sub             w12, w12, #1
+.rept 4
+    ld1             {v2.8h-v3.8h}, [x1], x2
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0], #32
+.endr
+    cbnz            w12, .loop_cpy2Dto1D_shl_16
+    ret
+endfunc
+
+function x265_cpy2Dto1D_shl_32x32_neon
+    cpy2Dto1D_shl_start
+    mov             w12, #16
+.loop_cpy2Dto1D_shl_32:
+    sub             w12, w12, #1
+.rept 2
+    ld1             {v2.8h-v5.8h}, [x1], x2
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    sshl            v4.8h, v4.8h, v0.8h
+    sshl            v5.8h, v5.8h, v0.8h
+    st1             {v2.8h-v5.8h}, [x0], #64
+.endr
+    cbnz            w12, .loop_cpy2Dto1D_shl_32
+    ret
+endfunc
+
+// void cpy2Dto1D_shr(int16_t* dst, const int16_t* src, intptr_t srcStride, int shift)
+.macro cpy2Dto1D_shr_start
+    add             x2, x2, x2
+    dup             v0.8h, w3
+    cmeq            v1.8h, v1.8h, v1.8h
+    sshl            v1.8h, v1.8h, v0.8h
+    sri             v1.8h, v1.8h, #1
+    neg             v0.8h, v0.8h
+.endm
+
+function x265_cpy2Dto1D_shr_4x4_neon
+    cpy2Dto1D_shr_start
+    ld1             {v2.d}[0], [x1], x2
+    ld1             {v2.d}[1], [x1], x2
+    ld1             {v3.d}[0], [x1], x2
+    ld1             {v3.d}[1], [x1], x2
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0]
+    ret
+endfunc
+
+function x265_cpy2Dto1D_shr_8x8_neon
+    cpy2Dto1D_shr_start
+.rept 4
+    ld1             {v2.16b}, [x1], x2
+    ld1             {v3.16b}, [x1], x2
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0], #32
+.endr
+    ret
+endfunc
+
+function x265_cpy2Dto1D_shr_16x16_neon
+    cpy2Dto1D_shr_start
+    mov             w12, #4
+.loop_cpy2Dto1D_shr_16:
+    sub             w12, w12, #1
+.rept 4
+    ld1             {v2.8h-v3.8h}, [x1], x2
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0], #32
+.endr
+    cbnz            w12, .loop_cpy2Dto1D_shr_16
+    ret
+endfunc
+
+function x265_cpy2Dto1D_shr_32x32_neon
+    cpy2Dto1D_shr_start
+    mov             w12, #16
+.loop_cpy2Dto1D_shr_32:
+    sub             w12, w12, #1
+.rept 2
+    ld1             {v2.8h-v5.8h}, [x1], x2
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sub             v4.8h, v4.8h, v1.8h
+    sub             v5.8h, v5.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    sshl            v4.8h, v4.8h, v0.8h
+    sshl            v5.8h, v5.8h, v0.8h
+    st1             {v2.8h-v5.8h}, [x0], #64
+.endr
+    cbnz            w12, .loop_cpy2Dto1D_shr_32
+    ret
+endfunc
+
+// void cpy1Dto2D_shl(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift)
+.macro cpy1Dto2D_shl_start
+    add             x2, x2, x2
+    dup             v0.8h, w3
+.endm
+
+function x265_cpy1Dto2D_shl_4x4_neon
+    cpy1Dto2D_shl_start
+    ld1             {v2.8h-v3.8h}, [x1]
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.d}[0], [x0], x2
+    st1             {v2.d}[1], [x0], x2
+    st1             {v3.d}[0], [x0], x2
+    st1             {v3.d}[1], [x0], x2
+    ret
+endfunc
+
+function x265_cpy1Dto2D_shl_8x8_neon
+    cpy1Dto2D_shl_start
+.rept 4
+    ld1             {v2.8h-v3.8h}, [x1], #32
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.16b}, [x0], x2
+    st1             {v3.16b}, [x0], x2
+.endr
+    ret
+endfunc
+
+function x265_cpy1Dto2D_shl_16x16_neon
+    cpy1Dto2D_shl_start
+    mov             w12, #4
+.loop_cpy1Dto2D_shl_16:
+    sub             w12, w12, #1
+.rept 4
+    ld1             {v2.8h-v3.8h}, [x1], #32
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0], x2
+.endr
+    cbnz            w12, .loop_cpy1Dto2D_shl_16
+    ret
+endfunc
+
+function x265_cpy1Dto2D_shl_32x32_neon
+    cpy1Dto2D_shl_start
+    mov             w12, #16
+.loop_cpy1Dto2D_shl_32:
+    sub             w12, w12, #1
+.rept 2
+    ld1             {v2.8h-v5.8h}, [x1], #64
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    sshl            v4.8h, v4.8h, v0.8h
+    sshl            v5.8h, v5.8h, v0.8h
+    st1             {v2.8h-v5.8h}, [x0], x2
+.endr
+    cbnz            w12, .loop_cpy1Dto2D_shl_32
+    ret
+endfunc
+
+// void cpy1Dto2D_shr(int16_t* dst, const int16_t* src, intptr_t dstStride, int shift)
+.macro cpy1Dto2D_shr_start
+    add             x2, x2, x2
+    dup             v0.8h, w3
+    cmeq            v1.8h, v1.8h, v1.8h
+    sshl            v1.8h, v1.8h, v0.8h
+    sri             v1.8h, v1.8h, #1
+    neg             v0.8h, v0.8h
+.endm
+
+function x265_cpy1Dto2D_shr_4x4_neon
+    cpy1Dto2D_shr_start
+    ld1             {v2.8h-v3.8h}, [x1]
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.d}[0], [x0], x2
+    st1             {v2.d}[1], [x0], x2
+    st1             {v3.d}[0], [x0], x2
+    st1             {v3.d}[1], [x0], x2
+    ret
+endfunc
+
+function x265_cpy1Dto2D_shr_8x8_neon
+    cpy1Dto2D_shr_start
+.rept 4
+    ld1             {v2.8h-v3.8h}, [x1], #32
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.16b}, [x0], x2
+    st1             {v3.16b}, [x0], x2
+.endr
+    ret
+endfunc
+
+function x265_cpy1Dto2D_shr_16x16_neon
+    cpy1Dto2D_shr_start
+    mov             w12, #4
+.loop_cpy1Dto2D_shr_16:
+    sub             w12, w12, #1
+.rept 4
+    ld1             {v2.8h-v3.8h}, [x1], #32
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    st1             {v2.8h-v3.8h}, [x0], x2
+.endr
+    cbnz            w12, .loop_cpy1Dto2D_shr_16
+    ret
+endfunc
+
+function x265_cpy1Dto2D_shr_32x32_neon
+    cpy1Dto2D_shr_start
+    mov             w12, #16
+.loop_cpy1Dto2D_shr_32:
+    sub             w12, w12, #1
+.rept 2
+    ld1             {v2.8h-v5.8h}, [x1], #64
+    sub             v2.8h, v2.8h, v1.8h
+    sub             v3.8h, v3.8h, v1.8h
+    sub             v4.8h, v4.8h, v1.8h
+    sub             v5.8h, v5.8h, v1.8h
+    sshl            v2.8h, v2.8h, v0.8h
+    sshl            v3.8h, v3.8h, v0.8h
+    sshl            v4.8h, v4.8h, v0.8h
+    sshl            v5.8h, v5.8h, v0.8h
+    st1             {v2.8h-v5.8h}, [x0], x2
+.endr
+    cbnz            w12, .loop_cpy1Dto2D_shr_32
+    ret
+endfunc
-- 
2.25.1

